diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index f4c5a0f09..84665e3d8 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -1184,9 +1184,9 @@ public class Minecraft
 
         if (leftClickDown && this.objectMouseOver instanceof final @NotNull HitResult.Tile hitTile) {
             final double xPlaced;
-            if (hitTile.side.getAxis() == Axis.X) {
+            if (hitTile.side.axis() == Axis.X) {
                 xPlaced = hitTile.location.x() - hitTile.tilePos.x();
-            } else if (hitTile.side.getAxis() == Axis.Z) {
+            } else if (hitTile.side.axis() == Axis.Z) {
                 xPlaced = hitTile.location.z() - hitTile.tilePos.z();
             } else {
                 xPlaced = hitTile.location.x() - hitTile.tilePos.x();
@@ -1225,9 +1225,9 @@ public class Minecraft
                         MathHelper.floor(this.thePlayer.z)
                     );
 
-                    Direction playerDirection = Direction.getHorizontalDirection(this.thePlayer);
+                    Direction playerDirection = Direction.getHorizontalLockable(this.thePlayer);
                     if (playerDirection.isVertical()) break bridge;
-                    Side side = playerDirection.getSide();
+                    Side side = playerDirection.side();
 
                     double yPlaced = 0.5d;
                     double xPlaced = 0.5d;
@@ -1262,9 +1262,9 @@ public class Minecraft
         } else if (this.objectMouseOver instanceof HitResult.Tile hitTile) {
             double xPlaced;
             double yPlaced = hitTile.location.y() - hitTile.tilePos.y();
-            if (hitTile.side.getAxis() == Axis.X) {
+            if (hitTile.side.axis() == Axis.X) {
                 xPlaced = hitTile.location.x() - hitTile.tilePos.x();
-            } else if (hitTile.side.getAxis() == Axis.Z) {
+            } else if (hitTile.side.axis() == Axis.Z) {
                 xPlaced = hitTile.location.z() - hitTile.tilePos.z();
             } else {
                 xPlaced = hitTile.location.x() - hitTile.tilePos.x();
@@ -1777,10 +1777,10 @@ public class Minecraft
                 GameSettings.ROTATION_OVERLAY_MODE.value++;
                 GameSettings.ROTATION_OVERLAY_MODE.value %= 4;
             } else {
-                if (this.thePlayer.rotationLock == null || this.thePlayer.rotationLock == Direction.NONE) {
-                    this.thePlayer.rotationLock = Direction.getDirection(this.thePlayer);
-                    this.thePlayer.rotationLockHorizontal = Direction.getHorizontalDirection(this.thePlayer);
-                    this.thePlayer.rotationLockVertical = Direction.getVerticalDirection(this.thePlayer);
+                if (this.thePlayer.rotationLock == null) {
+                    this.thePlayer.rotationLock = Direction.getLockable(this.thePlayer);
+                    this.thePlayer.rotationLockHorizontal = Direction.getHorizontalLockable(this.thePlayer);
+                    this.thePlayer.rotationLockVertical = Direction.getVerticalLockable(this.thePlayer);
                 } else {
                     this.thePlayer.rotationLock = null;
                     this.thePlayer.rotationLockHorizontal = null;
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
index 75279c62e..52068315a 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
@@ -441,8 +441,8 @@ public class PlayerLocal extends Player {
                 pushDirection = Direction.SOUTH;
             }
             final float pushStrength = 0.1F;
-            this.xd = pushDirection.getOffsetX() * pushStrength;
-            this.zd = pushDirection.getOffsetZ() * pushStrength;
+            this.xd = pushDirection.offsetX() * pushStrength;
+            this.zd = pushDirection.offsetZ() * pushStrength;
             return true;
         }
         return false;
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
index c1e672c65..96eda5d1a 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
@@ -237,9 +237,9 @@ public class PlayerLocalMultiplayer extends PlayerLocal implements Player.Player
     	super.syncPlacementMode();
     	
     	byte[] data = new byte[4];
-    	data[0] = (byte) (rotationLock != null ? rotationLock.getId() : -1);
-    	data[1] = (byte) (rotationLockHorizontal != null ? rotationLockHorizontal.getId() : -1);
-    	data[2] = (byte) (rotationLockVertical != null ? rotationLockVertical.getId() : -1);
+    	data[0] = (byte) (rotationLock != null ? rotationLock.id : -1);
+    	data[1] = (byte) (rotationLockHorizontal != null ? rotationLockHorizontal.id : -1);
+    	data[2] = (byte) (rotationLockVertical != null ? rotationLockVertical.id : -1);
     	data[3] = (byte) (placementModeOverride != null ? placementModeOverride.index() : -1);
     	
     	sendQueue.addToSendQueue(new PacketCustomPayload(PacketCustomPayload.CHANNEL_ROTATION_LOCK, data));
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index e315fd2c7..221b99f5e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -265,7 +265,7 @@ public class HudIngame extends Gui {
 
                     int yaw = DynamicTexture.pmod(java.lang.Math.round(this.mc.thePlayer.yRot), 360);
                     int pitch = java.lang.Math.round(this.mc.thePlayer.xRot);
-                    drawDebugScreenLine("Facing: " + yaw + "°, " + pitch + "° (" + I18n.getInstance().translateKey(getFacingDirection(this.mc.thePlayer).getTranslationKey()) + ")");
+                    drawDebugScreenLine("Facing: " + yaw + "°, " + pitch + "° (" + I18n.getInstance().translateKey(getFacingDirection(this.mc.thePlayer).translationKey) + ")");
                 } else {
                     drawDebugScreenLine("Hold a compass for more information");
                 }
@@ -366,9 +366,9 @@ public class HudIngame extends Gui {
                         int lightZ = hitTile.tilePos.z();
 
                         Side side = hitTile.side;
-                        lightX += side.getOffsetX();
-                        lightY += side.getOffsetY();
-                        lightZ += side.getOffsetZ();
+                        lightX += side.offsetX();
+                        lightY += side.offsetY();
+                        lightZ += side.offsetZ();
 
                         drawDebugScreenLineRight("Light: Sky: " + this.mc.currentWorld.getSavedLightValue(LightLayer.Sky, lightX, lightY, lightZ) + " Block: " + this.mc.currentWorld.getSavedLightValue(LightLayer.Block, lightX, lightY, lightZ));
                     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
index 61f3dbabf..a9b59b7a7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
@@ -103,7 +103,7 @@ public class HudComponentInfoOverlay extends HudComponentMovable {
                 }
             }
             if (GameSettings.DIRECTION_IN_OVERLAY.value) {
-                lines.add(new RenderLine(I18n.getInstance().translateKey(HudIngame.getFacingDirection(mc.thePlayer).getTranslationKey()), 0xFFFFFFFF));
+                lines.add(new RenderLine(I18n.getInstance().translateKey(HudIngame.getFacingDirection(mc.thePlayer).translationKey), 0xFFFFFFFF));
             }
         }
 
@@ -176,7 +176,7 @@ public class HudComponentInfoOverlay extends HudComponentMovable {
         }
 
         boolean dirEnabled = GameSettings.DIRECTION_IN_OVERLAY.value;
-        lines.add(new RenderLine(I18n.getInstance().translateKey(Direction.NORTH.getTranslationKey()), getPreviewColor(0xFFFFFFFF, dirEnabled)));
+        lines.add(new RenderLine(I18n.getInstance().translateKey(Direction.NORTH.translationKey), getPreviewColor(0xFFFFFFFF, dirEnabled)));
 
         int clockColor = (GameSettings.OVERLAY_MODE.value == 2) ? 0xFFFFFF80 : 0xFFFFFFFF;
         boolean timeEnabled = GameSettings.TIME_IN_OVERLAY.value;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentRotationLock.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentRotationLock.java
index 8e8e5f8b9..51c83c970 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentRotationLock.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentRotationLock.java
@@ -21,7 +21,7 @@ public class HudComponentRotationLock
         if (mc.thePlayer == null) {
             return GameSettings.IMMERSIVE_MODE.drawOverlays();
         }
-        return mc.thePlayer.rotationLock != null && mc.thePlayer.rotationLock != Direction.NONE && GameSettings.IMMERSIVE_MODE.drawOverlays();
+        return mc.thePlayer.rotationLock != null && GameSettings.IMMERSIVE_MODE.drawOverlays();
     }
 
     @Override
@@ -40,10 +40,10 @@ public class HudComponentRotationLock
         boolean facingUp = player.xRot < -45;
         boolean facingDown = player.xRot > 45;
 
-        Direction dir = Direction.getDirection(player);
+        Direction dir = Direction.getLockable(player);
 
         if (dir.isHorizontal()) {
-            dir = dir.rotate(-Direction.getHorizontalDirection(player.yRot).rotate(2).index);
+            dir = dir.rotateY(Direction.fromYaw(player.yRot).rotateY(2).legacyIndex());
 
             if (facingUp) {
                 if (dir == Direction.SOUTH) dir = Direction.UP;
@@ -70,10 +70,10 @@ public class HudComponentRotationLock
         }
 
         String[] dirTextures = new String[]{"down", "up", "back", "front", "left", "right"};
-        hud.drawGuiIcon(x, y, 16, 16, TextureRegistry.getTexture("minecraft:gui/hud/rotation/" + prefix + "_" + dirTextures[dir.getId()]));
-        dir = Direction.getVerticalDirection(player);
+        hud.drawGuiIcon(x, y, 16, 16, TextureRegistry.getTexture("minecraft:gui/hud/rotation/" + prefix + "_" + dirTextures[dir.id]));
+        dir = Direction.getVerticalLockable(player);
         dirTextures = new String[]{"downer", "upper", "back", "front", "left", "right"};
-        hud.drawGuiIcon(x + 16, y + 4, 8, 8, TextureRegistry.getTexture("minecraft:gui/hud/rotation/" + prefix + "_" + dirTextures[dir.getId()]));
+        hud.drawGuiIcon(x + 16, y + 4, 8, 8, TextureRegistry.getTexture("minecraft:gui/hud/rotation/" + prefix + "_" + dirTextures[dir.id]));
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
index f2dabc63c..b6f7835b4 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
@@ -27,6 +27,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.IPainted;
 import net.minecraft.core.block.piston.BlockLogicPistonBase;
 import net.minecraft.core.block.piston.BlockLogicPistonHead;
+import net.minecraft.core.block.piston.PistonCommon;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -217,13 +218,12 @@ public class ViewerCategoryBlock extends ModelViewerCategory<ViewerCategoryBlock
                     meta |= BlockLogicFullyRotatable.directionToMeta(Direction.SOUTH);
                 }
                 if (Block.hasLogicClass(block, BlockLogicPistonBase.class)) {
-                    meta |= Direction.SOUTH.getId();
+                    meta |= Direction.SOUTH.id;
                 }
                 if (Block.hasLogicClass(block, BlockLogicPistonHead.class)) {
-                    meta |= Direction.SOUTH.getId();
-                    if (block == Blocks.PISTON_HEAD_STEEL) {
-                        meta = BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STEEL, meta);
-                    }
+                    meta |= Direction.SOUTH.id;
+                    if (block == Blocks.PISTON_HEAD_STEEL)
+                        meta = PistonCommon.TYPE.set(meta, PistonCommon.TYPE_STEEL);
                 }
                 if (Block.hasLogicClass(block, BlockLogicLadder.class)) {
                     meta |= ((BlockLogicLadder)block.getLogic()).getMetaForSide(Side.SOUTH);
diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
index 7d210aca9..356fd58d1 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
@@ -77,7 +77,7 @@ public class PlayerControllerMP
     @Override
     public boolean useOrPlaceItemStackOnTile(final @NotNull Player player, final @NotNull World world, final @Nullable ItemStack itemStack, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xPlaced, final double yPlaced) {
         this.syncCurrentPlayItem();
-        this.packetHandler.addToSendQueue(new PacketUseOrPlaceItemStack(tilePos.x(), tilePos.y(), tilePos.z(), side.getDirection(), player.inventory.getCurrentItem(), xPlaced, yPlaced, PacketUseOrPlaceItemStack.TYPE_USE_OR_PLACE_ON_TILE));
+        this.packetHandler.addToSendQueue(new PacketUseOrPlaceItemStack(tilePos.x(), tilePos.y(), tilePos.z(), side.direction(), player.inventory.getCurrentItem(), xPlaced, yPlaced, PacketUseOrPlaceItemStack.TYPE_USE_OR_PLACE_ON_TILE));
         return super.useOrPlaceItemStackOnTile(player, world, itemStack, tilePos, side, xPlaced, yPlaced);
     }
 
@@ -91,7 +91,7 @@ public class PlayerControllerMP
     @Override
     public boolean placeItemStackOnTile(final @NotNull Player player, final @NotNull World world, final @Nullable ItemStack itemStack, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xPlaced, final double yPlaced) {
         this.syncCurrentPlayItem();
-        this.packetHandler.addToSendQueue(new PacketUseOrPlaceItemStack(tilePos.x(), tilePos.y(), tilePos.z(), side.getDirection(), player.inventory.getCurrentItem(), xPlaced, yPlaced, PacketUseOrPlaceItemStack.TYPE_PLACE_ONLY));
+        this.packetHandler.addToSendQueue(new PacketUseOrPlaceItemStack(tilePos.x(), tilePos.y(), tilePos.z(), side.direction(), player.inventory.getCurrentItem(), xPlaced, yPlaced, PacketUseOrPlaceItemStack.TYPE_PLACE_ONLY));
         return super.placeItemStackOnTile(player, world, itemStack, tilePos, side, xPlaced, yPlaced);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
index 28305d4eb..3158261e4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
@@ -180,7 +180,7 @@ public final class ParticleEngine {
                     double xp = blockPos.x() + (xx + 0.5D) / amount;
                     double yp = blockPos.y() + (yy + 0.5D) / amount;
                     double zp = blockPos.z() + (zz + 0.5D) / amount;
-                    Side side = Side.getSideById(this.rand.nextInt(6));
+                    Side side = Side.fromId(this.rand.nextInt(6));
                     add((new ParticleBlockBreaking(this.world, xp, yp, zp, xp - blockPos.x() - 0.5D, yp - blockPos.y() - 0.5D, zp - blockPos.z() - 0.5D, block, side, data)).init(blockPos));
                 }
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index e140ae371..42dd596ca 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -1890,10 +1890,10 @@ public class RenderGlobal
                 break;
 
             case EVENT_DISPENSER_PARTICLES: // Dispenser eject particles
-                Direction direction = Direction.getDirectionById(data);
-                int xOff = direction.getOffsetX();
-                int yOff = direction.getOffsetY();
-                int zOff = direction.getOffsetZ();
+                Direction direction = Direction.fromId(data);
+                int xOff = direction.offsetX();
+                int yOff = direction.offsetY();
+                int zOff = direction.offsetZ();
                 double px = (double) x + (double) xOff * 0.6D + 0.5D;
                 double py = (double) y + (double) yOff * 0.6D + 0.5D;
                 double pz = (double) z + (double) zOff * 0.6D + 0.5D;
@@ -1946,9 +1946,9 @@ public class RenderGlobal
                 break;
             case EVENT_CONDUIT_PORT_PARTICLES: // Conduit port open particles
                 Side s1 = unpackEventConduitSide(data);
-                int xO = s1.getOffsetX();
-                int yO = s1.getOffsetY();
-                int zO = s1.getOffsetZ();
+                int xO = s1.offsetX();
+                int yO = s1.offsetY();
+                int zO = s1.offsetZ();
                 double xP = (double) x + (double) xO * 0.6D + 0.5D;
                 double yP = (double) y + (double) yO * 0.6D + 0.5D;
                 double zP = (double) z + (double) zO * 0.6D + 0.5D;
@@ -1973,13 +1973,13 @@ public class RenderGlobal
 
                 double d = 0.0625;
 
-                Direction dir = Direction.directions[random.nextInt(Direction.directions.length)];
+                Direction dir = Direction.ID_MAP[random.nextInt(Direction.count)];
 
                 double lx = (double) x + random.nextFloat();
                 double ly = (double) y + random.nextFloat();
                 double lz = (double) z + random.nextFloat();
 
-                if (!this.world.isBlockOpaqueCube(x + dir.getOffsetX(), y + dir.getOffsetY(), z + dir.getOffsetZ())) {
+                if (!this.world.isBlockOpaqueCube(x + dir.offsetX(), y + dir.offsetY(), z + dir.offsetZ())) {
                     switch (dir) {
                         case UP -> ly = (y + 1) + d;
                         case DOWN -> ly = (y) - d;
@@ -2010,7 +2010,7 @@ public class RenderGlobal
 
     public static Side unpackEventConduitSide(int packed) {
         int sideId = (packed >> 4) & 0x07;
-        return Side.getSideById(sideId);
+        return Side.fromId(sideId);
     }
 
     public static int unpackEventConduitStrength(int packed) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
index e7e375603..663aaece5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
@@ -57,8 +57,8 @@ public class BlockModelAxisAligned<T extends BlockLogic> extends BlockModelStand
     }
 
     public Side getRotatedSide(Side side, int data) {
-        int d = (6 * (data & 3) + side.getId());
-        return d < Sides.orientationLookUpXYZAligned.length ? Side.getSideById(Sides.orientationLookUpXYZAligned[d]) : Side.NONE;
+        int d = (6 * (data & 3) + side.id);
+        return d < Sides.orientationLookUpXYZAligned.length ? Side.fromId(Sides.orientationLookUpXYZAligned[d]) : Side.NONE;
     }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 326f64167..92e9a6ad9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -386,6 +386,7 @@ public final class BlockModelDispatcher
 
         addDispatch(new BlockModelGenericRepeater<>(Blocks.REPEATER_IDLE));
         addDispatch(new BlockModelGenericRepeater<>(Blocks.REPEATER_ACTIVE));
+        addDispatch(new BlockModelGenericTimer<>(Blocks.TIMER));
 
         addDispatch(new BlockModelGenericPiston<>(Blocks.PISTON_BASE, loadDataModel("minecraft:block/piston/base"), loadDataModel("minecraft:block/piston/extended")));
         addDispatch(new BlockModelGenericPiston<>(Blocks.PISTON_BASE_STICKY, loadDataModel("minecraft:block/piston_sticky/base"), loadDataModel("minecraft:block/piston_sticky/extended")));
@@ -393,11 +394,27 @@ public final class BlockModelDispatcher
 
         addDispatch(new BlockModelEmpty<>(Blocks.PISTON_MOVING).setAllTextures((IconCoordinate) null));
         addDispatch(new BlockModelGenericPistonHead<>(Blocks.PISTON_HEAD,
-            loadDataModel("minecraft:block/piston/head"), loadDataModel("minecraft:block/piston_sticky/head"), loadDataModel("minecraft:block/piston_steel/head"),
-            loadDataModel("minecraft:block/piston/head_half"), loadDataModel("minecraft:block/piston_sticky/head_half"), loadDataModel("minecraft:block/piston_steel/head_half")));
+            loadDataModel("minecraft:block/piston/head"),
+            loadDataModel("minecraft:block/piston_sticky/head"),
+            loadDataModel("minecraft:block/piston_steel/head"),
+            // loadDataModel("minecraft:block/piston/head_half"),
+            // loadDataModel("minecraft:block/piston_sticky/head_half"),
+            // loadDataModel("minecraft:block/piston_steel/head_half"),
+            loadDataModel("minecraft:block/piston/head_short"),
+            loadDataModel("minecraft:block/piston_sticky/head_short"),
+            loadDataModel("minecraft:block/piston_steel/head_short")
+        ));
         addDispatch(new BlockModelGenericPistonHead<>(Blocks.PISTON_HEAD_STEEL,
-            loadDataModel("minecraft:block/piston/head"), loadDataModel("minecraft:block/piston_sticky/head"), loadDataModel("minecraft:block/piston_steel/head"),
-            loadDataModel("minecraft:block/piston/head_half"), loadDataModel("minecraft:block/piston_sticky/head_half"), loadDataModel("minecraft:block/piston_steel/head_half")));
+            loadDataModel("minecraft:block/piston/head"),
+            loadDataModel("minecraft:block/piston_sticky/head"),
+            loadDataModel("minecraft:block/piston_steel/head"),
+            // loadDataModel("minecraft:block/piston/head_half"),
+            // loadDataModel("minecraft:block/piston_sticky/head_half"),
+            // loadDataModel("minecraft:block/piston_steel/head_half"),
+            loadDataModel("minecraft:block/piston/head_short"),
+            loadDataModel("minecraft:block/piston_sticky/head_short"),
+            loadDataModel("minecraft:block/piston_steel/head_short")
+        ));
 
         addDispatch(new BlockModelGeneric<>(Blocks.NOTEBLOCK, loadDataModel("minecraft:block/noteblock")));
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
index 2f7d22214..a45b80f7d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
@@ -73,8 +73,8 @@ public class BlockModelDoor<T extends BlockLogicDoor> extends BlockModelStandard
     protected boolean shouldFlipTexture(@NotNull Side side, int meta) {
         if (side == Side.TOP || side == Side.BOTTOM) return false;
         int state = this.block.getLogic().getRotation(meta);
-        int l = state / 2 + (side.getId() & 1 ^ state);
-        if ((state == 0 || state == 2) ^ (side.getId() <= 3)) {
+        int l = state / 2 + (side.id & 1 ^ state);
+        if ((state == 0 || state == 2) ^ (side.id <= 3)) {
             return false;
         }
         l += (meta & 4) / 4;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
index f9645e68b..5e9a2d954 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
@@ -202,7 +202,7 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
                 case 2 -> posB.set(x - 1, y, z); // West
                 case 3 -> posB.set(x + 1, y, z); // East
             }
-            IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.getSideById(side + 2), meta);
+            IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.fromId(side + 2), meta);
             if (!renderBlocks.renderAllFaces && !sideRenderFlags[side]) {
                 continue;
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
index d8b60d364..7c24811eb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
@@ -71,9 +71,9 @@ public class BlockModelFullyRotatable<T extends BlockLogic> extends BlockModelSt
     @Override
     public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
         final Direction dir = BlockLogicFullyRotatable.metaToDirection(data);
-        if (side == dir.getSide()) {
+        if (side == dir.side()) {
             return this.blockTextures.get(Side.TOP);
         }
-        return side.getDirection() != dir.getOpposite() ? this.blockTextures.get(Side.NORTH) : this.blockTextures.get(Side.BOTTOM);
+        return side.direction() != dir.opposite() ? this.blockTextures.get(Side.NORTH) : this.blockTextures.get(Side.BOTTOM);
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java
index abdc96b9b..b11b7f690 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java
@@ -26,8 +26,8 @@ public class BlockModelHorizontalRotation<T extends BlockLogic> extends BlockMod
     @Override
     public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data)
     {
-        int index = Sides.orientationLookUpHorizontal[6 * Math.min(data & BlockLogicRotatable.MASK_DIRECTION, 5) + side.getId()];
+        int index = Sides.orientationLookUpHorizontal[6 * Math.min(data & BlockLogicRotatable.MASK_DIRECTION, 5) + side.id];
         if (index >= Sides.orientationLookUpHorizontal.length) return this.blockTextures.get(Side.BOTTOM);
-        return super.getBlockTextureFromSideAndMetadata(Side.getSideById(index), data);
+        return super.getBlockTextureFromSideAndMetadata(Side.fromId(index), data);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java
index d73c9d3f5..cc944aa94 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java
@@ -15,7 +15,7 @@ public class BlockModelRotatable<T extends BlockLogic> extends BlockModelStandar
 
     @Override
     public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
-        int index = Sides.orientationLookUp[6 * data + side.getId()];
-        return this.blockTextures.get(Side.getSideById(index));
+        int index = Sides.orientationLookUp[6 * data + side.id];
+        return this.blockTextures.get(Side.fromId(index));
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
index 666176f6e..0bd99cd7c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
@@ -276,7 +276,7 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T> {
         public TextureLayer set(@Nullable IconCoordinate coordinate, Side... sides) {
             for (Side s : sides) {
                 assert s != Side.NONE : "Cannot set texture on a 'NONE' side!";
-                this.coordinates[s.getId()] = coordinate;
+                this.coordinates[s.id] = coordinate;
             }
 
             this.hasTexture = false;
@@ -309,7 +309,7 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T> {
 
         public @Nullable IconCoordinate get(@NotNull Side side) {
             assert side != Side.NONE : "Cannot set texture on a 'NONE' side!";
-            return this.coordinates[side.getId()];
+            return this.coordinates[side.id];
         }
 
         public @Nullable IconCoordinate get(int index) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
index 14cf408fd..5ed5ccf1f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
@@ -79,10 +79,10 @@ public class BlockModelTrapDoor<T extends BlockLogic> extends BlockModelStandard
     public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
         int orientation = data & 0b11;
         if (BlockLogicTrapDoor.isTrapdoorOpen(data)) {
-            int index = Sides.orientationLookUpTrapdoorOpen[6 * orientation + side.getId()];
+            int index = Sides.orientationLookUpTrapdoorOpen[6 * orientation + side.id];
             return this.blockTextures.get(index);
         } else {
-            if (side.getAxis() == Axis.Y) {
+            if (side.axis() == Axis.Y) {
                 return this.blockTextures.get(Side.BOTTOM);
             } else {
                 return this.blockTextures.get(Side.SOUTH);
